//+------------------------------------------------------------------------------------------------------------------+
//                                                                    \/                           [!!!-MT4 X-RIBBON]
//                                                                   ( )
//______________________________________________________________o0o___(_)___o0o_______________________________________
#property copyright "Welcome to the World of Forex"
#property description "Let light shine out of darkness and illuminate your world"
#property indicator_chart_window
#property indicator_buffers 2
//+------------------------------------------------------------------------------------------------------------------+
extern int                FastPeriod=8;
extern int                SlowPeriod=50;
extern ENUM_MA_METHOD     CoreMode=MODE_LWMA;
extern ENUM_APPLIED_PRICE CorePrice=PRICE_TYPICAL; 
extern color RibColUP=clrForestGreen;
extern color RibColDN=clrBrown;
extern color LineCol=clrDarkGray;
extern string UniqueID="Ribbon1";
extern int    MaxBars=500;

double MA1[],MA2[];

int init() 
{
   SetIndexBuffer(0,MA1); SetIndexStyle(0,DRAW_LINE,EMPTY,4,LineCol);
   SetIndexBuffer(1,MA2); SetIndexStyle(1,DRAW_LINE,EMPTY,4,LineCol); 
   return(0);
}
int deinit()
{
   string lookFor       = UniqueID+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
      if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
   return (0);
}

//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars > 0) counted_bars--;
            int limit = MathMin(Bars-counted_bars,Bars-1);

   for(int i=limit; i>=0; i--)
   {
      MA1[i]=iMA(NULL,0,FastPeriod,0,CoreMode,CorePrice,i);
      MA2[i]=iMA(NULL,0,SlowPeriod,0,CoreMode,CorePrice,i);
      color theColor = RibColUP; if (MA1[i]<MA2[i]) theColor=RibColDN;
      string oname = UniqueID+":u"+(string)Time[i]; ObjectDelete(oname);
             oname = UniqueID+":d"+(string)Time[i]; ObjectDelete(oname);
             if (i<MaxBars)
             drawFill(UniqueID,0,Time[i],Time[i+1],MA1[i],MA1[i+1],MA2[i],MA2[i+1],theColor);
      
   } 
   return(0);
}
//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//
//

void drawFill(string name, int window, datetime time1, datetime time2, double priceu1, double priceu2, double priced1, double priced2, color fillColor)
{
   string oname = name+":u"+(string)time1;
            ObjectDelete(oname);
               ObjectCreate(ChartID(),oname,OBJ_TRIANGLE,window,time1,priceu1,time2,priceu2,time1,priced1);
               ObjectSet(oname,OBJPROP_COLOR,fillColor);
               ObjectSet(oname,OBJPROP_BORDER_COLOR,fillColor);
               ObjectSet(oname,OBJPROP_BACK,true);
               ObjectSet(oname,OBJPROP_SELECTABLE,false);
               ObjectSet(oname,OBJPROP_HIDDEN,true);
         oname = name+":d"+(string)time1;
            ObjectDelete(oname);
               ObjectCreate(ChartID(),oname,OBJ_TRIANGLE,window,time1,priced1,time2,priced2,time2,priceu2);
               ObjectSet(oname,OBJPROP_COLOR,fillColor);
               ObjectSet(oname,OBJPROP_BACK,true);
               ObjectSet(oname,OBJPROP_BORDER_COLOR,fillColor);
               ObjectSet(oname,OBJPROP_SELECTABLE,false);
               ObjectSet(oname,OBJPROP_HIDDEN,true);
}
